/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */

/* PC - Interrupt Functions */

#include "sysconfi.h"                   // includes/sysconfig.h
#include "sysdeps.h"
#include "config.h"
#include "custom2.h"                    // includes/vMac_custom.h
#include "VIA.h"
#include "Interrup.h"                   // hardware/VIA_interrupts.h
#include "Interfac.h"                   // hardware/VIA_interface.h
#include "Screen.h"
#include "RTC.h"
#include "Mouse.h"
#include "Sony.h"
#include "scsi.h"
#include "debug.h"
#include "prefs.h"
#include "Unix/universa.h"              // unix/universal.h

#include <sys/time.h>

unsigned long int Instruction_Counter = 0;
volatile int skip_count = 0;
volatile int buttonstate;
static int VBL_Counter = 0;
static long int Mouse_Counter = 0;
static int VIA_Counter = 0;
static long int ClockTick = 0;
static long int OldClockTick = 0;
unsigned long int Instrucs;

void Int_Handler (void);

int Interrupt_Init (void)
{
   Instruction_Counter = 0;
   VIA_Counter = 0;
   Mouse_Counter = 0;
   VBL_Counter = 0;
   return 0;
}

void Interrupt_Reset (void)
{
   (void) Interrupt_Init();
}

void Int_Handler (void)
{
}

void Interrupt_Timing (void)
{
   extern int InstallTimer2(void);
   extern void UninstallTimer(void);

   Instruction_Counter++;
   VIA_Counter++;

   // Clock = 7833600 Hz (7.8336 mHz)
   // At best, we can get 3916800 instructions per second
   // Normally, it's probably a lot lower than that, say
   // 783360 instructions/sec if there's 10 cycles per instr.
               
   // skip memory test                    
   if (thePrefs.Skip) {
      if (skip_count<30) {
         buttonstate=1;
      } else {
         if (skip_count>30 && skip_count<35) {
            buttonstate=0;
         } else {
            buttonstate=buttonstate;
         }
      }  
   }

   if ((VIA_Counter % 4) == 0) {
      VIA_Counter = 0;
      VIA_Timer();
   }

//   SCSI_Check();

   if ((Instruction_Counter % thePrefs.Instrucs)==0)
   {
      extern void Sound_Play(void);
      Mouse_Update2();
      Screen_Draw();

      if (thePrefs.Sound) Sound_Play();

      Instruction_Counter = 0;
      VBL_Counter++;
      ++skip_count;

      VIA_Int(Vertical_Blanking);

      ClockTick = clock();

      if (ClockTick >= OldClockTick + (CLOCKS_PER_SEC - 2)) {
         VBL_Counter = 60;
         OldClockTick = ClockTick;
      } else {
         VBL_Counter = 1;
      }

      if ((VBL_Counter % 60) == 0) {
         VBL_Counter = 0;
         Sony_Update();
         RTC_Interrupt();
         VIA_Int(One_Second);
      }
   }
}
