// PC - Native Code Functions

#include "sysconfi.h"                   // includes/sysconfig.h
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "memory2.h"                    // includes/memory.h

#include "Memory.h"
#include "uaepatch.h"                   // includes/uae_vmac_patch.h
#include "custom2.h"                    // includes/vMac_custom.h

#include "readcpu.h"
#include "newcpu.h"
#include "debug.h"

#include "Native.h"
#include "Sony.h"

#include "r_newcpu.h"                   // includes/reentrant_newcpu.h

#include "Unix/universa.h"              // unix/universal.h

static int Installed = 0;

unsigned long iteration_count = 0;

void Install_Patch (void)
{
  return;
}

#define _Sony_Enabled

int Check_Patch (void)
{
#ifdef _Sony_Enabled
   if (Check_Sony_Patch() == 1) // Check if we want to transparently patch
      return 1;
#endif

   return 0; // Not a transparent patch
}

int Check_Illegal (void)
{
#ifdef _Sony_Enabled
  if (Check_Sony_Illegal() == 1) // Check if a Sony call
    return 1;
#endif

  return 0; // Not handled, do Illegal
}

void Call_ATrap (UWORD ATrap_instruction_word)
{
   CPTR ATrap_termination_program_counter, VM_instruction_word_address;
   UWORD actual_instruction_word, *real_overridden_instruction_word_address;
   unsigned long   instruction_count;

   ATrap_termination_program_counter = m68k_getpc() + 2;
   ROMmem_write_enable_set(on);
   VM_instruction_word_address = m68k_getpc();
   actual_instruction_word = get_word(VM_instruction_word_address);
   put_word(VM_instruction_word_address, ATrap_instruction_word);

   // This sets up the exception stack frame...
   Exception(0x0A, 0);
   instruction_count=0;
   iteration_count++;
   // Basically this block iterates until the A-Line Trap is finished ...
   do {
      instruction_count++;
      reentrant_m68k_step();
   } while (ATrap_termination_program_counter != m68k_getpc());

   put_word(VM_instruction_word_address, actual_instruction_word);

   m68k_setpc(ATrap_termination_program_counter - 2);

   /* Michael - Set to 'off' */
   ROMmem_write_enable_set(off);
}

void Run_ATrap (void)
{
   CPTR NextPC = 0;

   NextPC = m68k_getpc() + 2;
   Exception(0x0A, 0);

   do {
      reentrant_m68k_step();
   } while (NextPC != m68k_getpc());
}
