/*
   vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997
*/

#include "sysconfi.h"                   // includes/sysconfig.h
#include "sysdeps.h"
#include "config.h"
#include "options.h"

#include "prefs.h"
#include "memory2.h"                    // includes/memory.h

#include "custom2.h"                    // includes/vMac_custom.h
#include "readcpu.h"
#include "newcpu.h"
#include "debug.h"

#include "Memory.h"
#include "Sony.h"
#include "Screen.h"
#include "Trap.h"

#include <dpmi.h>
#include <go32.h>

_go32_dpmi_registers Regs;

int Install=1;
int use_debugger = 0;
char ConfigFile[] = "vMac.cfg";
extern void debug(void);

void Quit_vMac(void);
void Help(void);
void Parse(int argc, char **argv);

void Quit_vMac(void)
{
   extern void UninstallSound (void);

   PrefsSave(ConfigFile);
   fprintf(stderr, "vMac: quit ok.\nvMac: %s saved.\n", ConfigFile);
   UninstallSound();
   UninstallExceptionHandler();
   exit(0);
}  

void Help (void)
{
   printf("vMac: The Virtual Macintosh Emulator.    \n");
   printf("      version %s for MS-DOS systems.\n\n", VMACVERSION);
   printf("Summary of command-line options:         \n");
   printf("  -h, --help              : Print help   \n");
   printf("  -c, --config [filename] : Use a different file for config instead of vMac.cfg\n");
}

void Parse (int argc, char **argv)
{
   int i;
   
   for (i=1; i<argc; i++) {
      if ((!strcmp(argv[i], "-u")) || (!strcmp(argv[i], "--uninstall"))) {
         Install=0;
      }
      else if ((!strcmp(argv[i], "-h")) || (!strcmp(argv[i], "--help"))) {
         Help();
         exit(0);
      }
      else if ((!strcmp(argv[i], "-c")) || (!strcmp(argv[i], "--config"))) {
         i++;
         strcpy(ConfigFile, argv[i]);
      }
      else {
         printf("vMac: syntax error: %s\n", argv[i]);
         exit(0);
      }
   }
}

void main(int argc, char **argv)
{
   Parse(argc, argv);

   printf("vMac: The Virtual Macintosh Emulator.    \n");
   printf("      version %s for MS-DOS systems.\n\n", VMACVERSION);

   PrefsLoad(ConfigFile);

   if (Install==1) {
      InstallExceptionHandler();
   }

   if (custominit() == 0) {
      extern int InstallSound(void);

      m68k_reset();
      if (InstallSound()) Quit_vMac();
      init_m68k();
      Screen_Init(argc, argv);

      use_debugger=0;
      debug();
     
   } else {
      fprintf(stderr, "vMac: Sorry, errors encountered - cannot continue.\n");
   }
}

