// Cross Platform Compatible Preferences Code for vMac
// (C) 1997 Richard Bannister

// Based on code from Frodo - (C) 1994-1997 Christian Bauer

#include "sysconfig.h"
#include "sysdeps.h"
#include "prefs.h"
#include "keys.h"

Prefs thePrefs;

void PrefsLoad(char *filename)
{
   FILE *file;
   char line[256], keyword[256], value[256];

   // Initialise the prefs with valid values
   thePrefs.Skip=0;
   thePrefs.INSERT1=_F1;
   thePrefs.INSERT2=_F2;
   thePrefs.INSERT3=_F3;
   thePrefs.INSERT4=_F4;
   thePrefs.DEBUG=_F9;
   thePrefs.EXIT=_F10;
   thePrefs.INTERRUPT=_F11;
   thePrefs.RESET=_F12;
   thePrefs.COMMAND=0;
   thePrefs.OPTION=3;
   thePrefs.FrameRate=1;
   thePrefs.Sound=1;
   strcpy(thePrefs.DrivePath[0], "");
   strcpy(thePrefs.DrivePath[1], "");
   strcpy(thePrefs.DrivePath[2], "");
   strcpy(thePrefs.DrivePath[3], "");
   strcpy(thePrefs.ROMPath[1],"vMac.ROM");
   thePrefs.CurrentROMPath=1;
   thePrefs.RAMSize=1;
   thePrefs.Instrucs=44050;

   if ((file = fopen(filename, "r")) != NULL) {
      while (fgets(line, 255, file)) {
         if (sscanf(line, "%s = %s\n", keyword, value) == 2) {
            if (!strcmp(keyword, "SkipMemoryTest")) {
               if (!strcmp(value, "1"))
                  thePrefs.Skip=1;
               else
                  thePrefs.Skip=0;
            }
          
            if (!strcmp(keyword, "InsertDisk1")) {
               if (!strcmp(value, "F1"))  thePrefs.INSERT1=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.INSERT1=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.INSERT1=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.INSERT1=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.INSERT1=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.INSERT1=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.INSERT1=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.INSERT1=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.INSERT1=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.INSERT1=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.INSERT1=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.INSERT1=_F12;
            }

            if (!strcmp(keyword, "InsertDisk2")) {
               if (!strcmp(value, "F1"))  thePrefs.INSERT2=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.INSERT2=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.INSERT2=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.INSERT2=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.INSERT2=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.INSERT2=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.INSERT2=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.INSERT2=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.INSERT2=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.INSERT2=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.INSERT2=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.INSERT2=_F12;
            }

            if (!strcmp(keyword, "InsertDisk3")) {
               if (!strcmp(value, "F1"))  thePrefs.INSERT3=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.INSERT3=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.INSERT3=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.INSERT3=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.INSERT3=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.INSERT3=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.INSERT3=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.INSERT3=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.INSERT3=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.INSERT3=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.INSERT3=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.INSERT3=_F12;
            }

            if (!strcmp(keyword, "InsertDisk4")) {
               if (!strcmp(value, "F1"))  thePrefs.INSERT4=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.INSERT4=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.INSERT4=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.INSERT4=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.INSERT4=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.INSERT4=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.INSERT4=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.INSERT4=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.INSERT4=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.INSERT4=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.INSERT4=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.INSERT4=_F12;
            }

            if (!strcmp(keyword, "Debugger")) {
               if (!strcmp(value, "F1"))  thePrefs.DEBUG=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.DEBUG=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.DEBUG=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.DEBUG=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.DEBUG=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.DEBUG=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.DEBUG=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.DEBUG=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.DEBUG=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.DEBUG=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.DEBUG=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.DEBUG=_F12;
            }

            if (!strcmp(keyword, "ShutDown")) {
               if (!strcmp(value, "F1"))  thePrefs.EXIT=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.EXIT=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.EXIT=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.EXIT=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.EXIT=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.EXIT=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.EXIT=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.EXIT=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.EXIT=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.EXIT=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.EXIT=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.EXIT=_F12;
            }

            if (!strcmp(keyword, "InterruptKey")) {
               if (!strcmp(value, "F1"))  thePrefs.INTERRUPT=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.INTERRUPT=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.INTERRUPT=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.INTERRUPT=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.INTERRUPT=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.INTERRUPT=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.INTERRUPT=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.INTERRUPT=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.INTERRUPT=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.INTERRUPT=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.INTERRUPT=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.INTERRUPT=_F12;
            }

            if (!strcmp(keyword, "ResetKey")) {
               if (!strcmp(value, "F1"))  thePrefs.RESET=_F1;
               else if (!strcmp(value, "F2"))  thePrefs.RESET=_F2;
               else if (!strcmp(value, "F3"))  thePrefs.RESET=_F3;
               else if (!strcmp(value, "F4"))  thePrefs.RESET=_F4;
               else if (!strcmp(value, "F5"))  thePrefs.RESET=_F5;
               else if (!strcmp(value, "F6"))  thePrefs.RESET=_F6;
               else if (!strcmp(value, "F7"))  thePrefs.RESET=_F7;
               else if (!strcmp(value, "F8"))  thePrefs.RESET=_F8;
               else if (!strcmp(value, "F9"))  thePrefs.RESET=_F9;
               else if (!strcmp(value, "F10"))  thePrefs.RESET=_F10;
               else if (!strcmp(value, "F11"))  thePrefs.RESET=_F11;
               else if (!strcmp(value, "F12"))  thePrefs.RESET=_F12;
            }

            if ((thePrefs.INSERT1==thePrefs.INSERT2) ||
                (thePrefs.INSERT1==thePrefs.INSERT3) ||
                (thePrefs.INSERT1==thePrefs.INSERT4) ||
                (thePrefs.INSERT1==thePrefs.DEBUG)   ||
                (thePrefs.INSERT1==thePrefs.EXIT)    ||
                (thePrefs.INSERT1==thePrefs.INTERRUPT) ||
                (thePrefs.INSERT1==thePrefs.RESET)   ||
                (thePrefs.INSERT2==thePrefs.INSERT3) ||
                (thePrefs.INSERT2==thePrefs.INSERT4) ||
                (thePrefs.INSERT2==thePrefs.DEBUG)   ||
                (thePrefs.INSERT2==thePrefs.EXIT)    ||
                (thePrefs.INSERT2==thePrefs.INTERRUPT) ||
                (thePrefs.INSERT2==thePrefs.RESET)   ||
                (thePrefs.INSERT3==thePrefs.INSERT4) ||
                (thePrefs.INSERT3==thePrefs.DEBUG)   ||
                (thePrefs.INSERT3==thePrefs.EXIT)    ||
                (thePrefs.INSERT3==thePrefs.INTERRUPT) ||
                (thePrefs.INSERT3==thePrefs.RESET)   ||
                (thePrefs.INSERT4==thePrefs.DEBUG)   ||
                (thePrefs.INSERT4==thePrefs.EXIT)    ||
                (thePrefs.INSERT4==thePrefs.INTERRUPT) ||
                (thePrefs.INSERT4==thePrefs.RESET)   ||
                (thePrefs.DEBUG  ==thePrefs.EXIT)    ||
                (thePrefs.DEBUG  ==thePrefs.INTERRUPT) ||
                (thePrefs.DEBUG  ==thePrefs.RESET)   ||
                (thePrefs.EXIT   ==thePrefs.INTERRUPT) ||
                (thePrefs.EXIT   ==thePrefs.RESET)   ||
                (thePrefs.INTERRUPT==thePrefs.RESET)) {
               fprintf(stderr, "vMac: error in .cfg file: you cannot assign the same key more than once.\n");
               exit(0);
            }

            if (!strcmp(keyword, "CommandKey")) {
               if (!strcmp(value, "0"))  thePrefs.COMMAND=0;
               else if (!strcmp(value, "1"))  thePrefs.COMMAND=1;
               else if (!strcmp(value, "2"))  thePrefs.COMMAND=2;
               else if (!strcmp(value, "3"))  thePrefs.COMMAND=3;
               else if (!strcmp(value, "4"))  thePrefs.COMMAND=4;
               else if (!strcmp(value, "5"))  thePrefs.COMMAND=5;
            }

            if (!strcmp(keyword, "OptionKey")) {
               if (!strcmp(value, "0"))  thePrefs.OPTION=0;
               else if (!strcmp(value, "1"))  thePrefs.OPTION=1;
               else if (!strcmp(value, "2"))  thePrefs.OPTION=2;
               else if (!strcmp(value, "3"))  thePrefs.OPTION=3;
               else if (!strcmp(value, "4"))  thePrefs.OPTION=4;
               else if (!strcmp(value, "5"))  thePrefs.OPTION=5;
            }

            if (((thePrefs.OPTION==0) && (thePrefs.COMMAND==1)) ||
                ((thePrefs.OPTION==0) && (thePrefs.COMMAND==2)) ||
                ((thePrefs.OPTION==0) && (thePrefs.COMMAND==0)) ||
                ((thePrefs.OPTION==3) && (thePrefs.COMMAND==4)) ||
                ((thePrefs.OPTION==3) && (thePrefs.COMMAND==5)) ||
                ((thePrefs.OPTION==3) && (thePrefs.COMMAND==3))) {
               fprintf(stderr, "vMac: error in .cfg file: you cannot assign the same key more than once.\n");
               exit(0);
            }

            if (!strcmp(keyword, "FrameRate")) {
               if (!strcmp(value, "1"))  thePrefs.FrameRate = 1;
               else if (!strcmp(value, "2"))  thePrefs.FrameRate = 2;
               else if (!strcmp(value, "3"))  thePrefs.FrameRate = 3;
               else if (!strcmp(value, "4"))  thePrefs.FrameRate = 4;
               else if (!strcmp(value, "5"))  thePrefs.FrameRate = 5;
               else if (!strcmp(value, "6"))  thePrefs.FrameRate = 6;
               else if (!strcmp(value, "7"))  thePrefs.FrameRate = 7;
               else if (!strcmp(value, "8"))  thePrefs.FrameRate = 8;
               else if (!strcmp(value, "9"))  thePrefs.FrameRate = 9;
               else if (!strcmp(value, "10"))  thePrefs.FrameRate = 10;
            }

            if (!strcmp(keyword, "Sound")) {
               if (!strcmp(value, "1"))
                  thePrefs.Sound=1;
               else
                  thePrefs.Sound=0;
            }

            if (!strcmp(keyword, "RAMSize")) {
               if (!strcmp(value, "1"))  thePrefs.RAMSize = 1;
               else if (!strcmp(value, "2"))  thePrefs.RAMSize = 2;
               else if (!strcmp(value, "4"))  thePrefs.RAMSize = 4;
            } 

            if (!strcmp(keyword, "DrivePath1"))
               strcpy(thePrefs.DrivePath[1], value);

            if (!strcmp(keyword, "DrivePath2"))
               strcpy(thePrefs.DrivePath[2], value);

            if (!strcmp(keyword, "DrivePath3"))
               strcpy(thePrefs.DrivePath[3], value);

            if (!strcmp(keyword, "ROMPath1"))
               strcpy(thePrefs.ROMPath[1],value);

            if (!strcmp(keyword, "ROMPath2"))
               strcpy(thePrefs.ROMPath[2],value);

            if (!strcmp(keyword, "ROMPath3"))
               strcpy(thePrefs.ROMPath[3],value);

            if (!strcmp(keyword, "CurrentROMPath")) {
               if (!strcmp(value, "1"))  thePrefs.CurrentROMPath = 1;
               if (!strcmp(value, "2"))  thePrefs.CurrentROMPath = 2;
               if (!strcmp(value, "3"))  thePrefs.CurrentROMPath = 3;
            }

            if (!strcmp(keyword, "CPU")) {
               thePrefs.Instrucs = atol(value);
            }
         }
      }
      fclose(file);
   }
}

void PrefsSave(char *filename)
{
   FILE *file;
   char INSERT1[3], INSERT2[3], INSERT3[3], INSERT4[3],
        DEBUG[3], EXIT[3], INTERRUPT[3], RESET[3];

   if (thePrefs.INSERT1==_F1)  strcpy(INSERT1, "F1");
   if (thePrefs.INSERT1==_F2)  strcpy(INSERT1, "F2");
   if (thePrefs.INSERT1==_F3)  strcpy(INSERT1, "F3");
   if (thePrefs.INSERT1==_F4)  strcpy(INSERT1, "F4");
   if (thePrefs.INSERT1==_F5)  strcpy(INSERT1, "F5");
   if (thePrefs.INSERT1==_F6)  strcpy(INSERT1, "F6");
   if (thePrefs.INSERT1==_F7)  strcpy(INSERT1, "F7");
   if (thePrefs.INSERT1==_F8)  strcpy(INSERT1, "F8");
   if (thePrefs.INSERT1==_F9)  strcpy(INSERT1, "F9");
   if (thePrefs.INSERT1==_F10)  strcpy(INSERT1, "F10");
   if (thePrefs.INSERT1==_F11)  strcpy(INSERT1, "F11");
   if (thePrefs.INSERT1==_F12)  strcpy(INSERT1, "F12");

   if (thePrefs.INSERT2==_F1)  strcpy(INSERT2, "F1");
   if (thePrefs.INSERT2==_F2)  strcpy(INSERT2, "F2");
   if (thePrefs.INSERT2==_F3)  strcpy(INSERT2, "F3");
   if (thePrefs.INSERT2==_F4)  strcpy(INSERT2, "F4");
   if (thePrefs.INSERT2==_F5)  strcpy(INSERT2, "F5");
   if (thePrefs.INSERT2==_F6)  strcpy(INSERT2, "F6");
   if (thePrefs.INSERT2==_F7)  strcpy(INSERT2, "F7");
   if (thePrefs.INSERT2==_F8)  strcpy(INSERT2, "F8");
   if (thePrefs.INSERT2==_F9)  strcpy(INSERT2, "F9");
   if (thePrefs.INSERT2==_F10)  strcpy(INSERT2, "F10");
   if (thePrefs.INSERT2==_F11)  strcpy(INSERT2, "F11");
   if (thePrefs.INSERT2==_F12)  strcpy(INSERT2, "F12");

   if (thePrefs.INSERT3==_F1)  strcpy(INSERT3, "F1");
   if (thePrefs.INSERT3==_F2)  strcpy(INSERT3, "F2");
   if (thePrefs.INSERT3==_F3)  strcpy(INSERT3, "F3");
   if (thePrefs.INSERT3==_F4)  strcpy(INSERT3, "F4");
   if (thePrefs.INSERT3==_F5)  strcpy(INSERT3, "F5");
   if (thePrefs.INSERT3==_F6)  strcpy(INSERT3, "F6");
   if (thePrefs.INSERT3==_F7)  strcpy(INSERT3, "F7");
   if (thePrefs.INSERT3==_F8)  strcpy(INSERT3, "F8");
   if (thePrefs.INSERT3==_F9)  strcpy(INSERT3, "F9");
   if (thePrefs.INSERT3==_F10)  strcpy(INSERT3, "F10");
   if (thePrefs.INSERT3==_F11)  strcpy(INSERT3, "F11");
   if (thePrefs.INSERT3==_F12)  strcpy(INSERT3, "F12");

   if (thePrefs.INSERT4==_F1)  strcpy(INSERT4, "F1");
   if (thePrefs.INSERT4==_F2)  strcpy(INSERT4, "F2");
   if (thePrefs.INSERT4==_F3)  strcpy(INSERT4, "F3");
   if (thePrefs.INSERT4==_F4)  strcpy(INSERT4, "F4");
   if (thePrefs.INSERT4==_F5)  strcpy(INSERT4, "F5");
   if (thePrefs.INSERT4==_F6)  strcpy(INSERT4, "F6");
   if (thePrefs.INSERT4==_F7)  strcpy(INSERT4, "F7");
   if (thePrefs.INSERT4==_F8)  strcpy(INSERT4, "F8");
   if (thePrefs.INSERT4==_F9)  strcpy(INSERT4, "F9");
   if (thePrefs.INSERT4==_F10)  strcpy(INSERT4, "F10");
   if (thePrefs.INSERT4==_F11)  strcpy(INSERT4, "F11");
   if (thePrefs.INSERT4==_F12)  strcpy(INSERT4, "F12");

   if (thePrefs.DEBUG==_F1)  strcpy(DEBUG, "F1");
   if (thePrefs.DEBUG==_F2)  strcpy(DEBUG, "F2");
   if (thePrefs.DEBUG==_F3)  strcpy(DEBUG, "F3");
   if (thePrefs.DEBUG==_F4)  strcpy(DEBUG, "F4");
   if (thePrefs.DEBUG==_F5)  strcpy(DEBUG, "F5");
   if (thePrefs.DEBUG==_F6)  strcpy(DEBUG, "F6");
   if (thePrefs.DEBUG==_F7)  strcpy(DEBUG, "F7");
   if (thePrefs.DEBUG==_F8)  strcpy(DEBUG, "F8");
   if (thePrefs.DEBUG==_F9)  strcpy(DEBUG, "F9");
   if (thePrefs.DEBUG==_F10)  strcpy(DEBUG, "F10");
   if (thePrefs.DEBUG==_F11)  strcpy(DEBUG, "F11");
   if (thePrefs.DEBUG==_F12)  strcpy(DEBUG, "F12");

   if (thePrefs.EXIT==_F1)  strcpy(EXIT, "F1");
   if (thePrefs.EXIT==_F2)  strcpy(EXIT, "F2");
   if (thePrefs.EXIT==_F3)  strcpy(EXIT, "F3");
   if (thePrefs.EXIT==_F4)  strcpy(EXIT, "F4");
   if (thePrefs.EXIT==_F5)  strcpy(EXIT, "F5");
   if (thePrefs.EXIT==_F6)  strcpy(EXIT, "F6");
   if (thePrefs.EXIT==_F7)  strcpy(EXIT, "F7");
   if (thePrefs.EXIT==_F8)  strcpy(EXIT, "F8");
   if (thePrefs.EXIT==_F9)  strcpy(EXIT, "F9");
   if (thePrefs.EXIT==_F10)  strcpy(EXIT, "F10");
   if (thePrefs.EXIT==_F11)  strcpy(EXIT, "F11");
   if (thePrefs.EXIT==_F12)  strcpy(EXIT, "F12");

   if (thePrefs.INTERRUPT==_F1)  strcpy(INTERRUPT, "F1");
   if (thePrefs.INTERRUPT==_F2)  strcpy(INTERRUPT, "F2");
   if (thePrefs.INTERRUPT==_F3)  strcpy(INTERRUPT, "F3");
   if (thePrefs.INTERRUPT==_F4)  strcpy(INTERRUPT, "F4");
   if (thePrefs.INTERRUPT==_F5)  strcpy(INTERRUPT, "F5");
   if (thePrefs.INTERRUPT==_F6)  strcpy(INTERRUPT, "F6");
   if (thePrefs.INTERRUPT==_F7)  strcpy(INTERRUPT, "F7");
   if (thePrefs.INTERRUPT==_F8)  strcpy(INTERRUPT, "F8");
   if (thePrefs.INTERRUPT==_F9)  strcpy(INTERRUPT, "F9");
   if (thePrefs.INTERRUPT==_F10)  strcpy(INTERRUPT, "F10");
   if (thePrefs.INTERRUPT==_F11)  strcpy(INTERRUPT, "F11");
   if (thePrefs.INTERRUPT==_F12)  strcpy(INTERRUPT, "F12");

   if (thePrefs.RESET==_F1)  strcpy(RESET, "F1");
   if (thePrefs.RESET==_F2)  strcpy(RESET, "F2");
   if (thePrefs.RESET==_F3)  strcpy(RESET, "F3");
   if (thePrefs.RESET==_F4)  strcpy(RESET, "F4");
   if (thePrefs.RESET==_F5)  strcpy(RESET, "F5");
   if (thePrefs.RESET==_F6)  strcpy(RESET, "F6");
   if (thePrefs.RESET==_F7)  strcpy(RESET, "F7");
   if (thePrefs.RESET==_F8)  strcpy(RESET, "F8");
   if (thePrefs.RESET==_F9)  strcpy(RESET, "F9");
   if (thePrefs.RESET==_F10)  strcpy(RESET, "F10");
   if (thePrefs.RESET==_F11)  strcpy(RESET, "F11");
   if (thePrefs.RESET==_F12)  strcpy(RESET, "F12");

   if ((file = fopen(filename, "w")) != NULL) {
      fprintf(file, "// vMac Configuration File\n");
      fprintf(file, "//\n");
        
      fprintf(file, "\n");
        
      fprintf(file, "// Do you wish to skip the Macintosh power-on memory \n");
      fprintf(file, "// test ?  This might be useful on slower computers  \n");
      fprintf(file, "// or when the there's a large RAM size [see below]  \n");
      fprintf(file, "// (Do memory test = 0, Skip memory test = 1).     \n\n");
      fprintf(file, "SkipMemoryTest = %d\n\n", thePrefs.Skip);

      fprintf(file, "// Keyboard configuration: F-keys                         \n");
      fprintf(file, "// (F1..F12 ; Please do not enter the same value more than\n");
      fprintf(file, "// once).                                               \n\n");
      fprintf(file, "InsertDisk1 = %s\n", INSERT1);
      fprintf(file, "InsertDisk2 = %s\n", INSERT2);
      fprintf(file, "InsertDisk3 = %s\n", INSERT3);
      fprintf(file, "InsertDisk4 = %s\n", INSERT4);
      fprintf(file, "Debugger = %s\n", DEBUG);
      fprintf(file, "ShutDown = %s\n", EXIT);
      fprintf(file, "InterruptKey = %s\n", INTERRUPT);
      fprintf(file, "ResetKey = %s\n\n", RESET);

      fprintf(file, "// Keyboard configuration: Modifier keys               \n");
      fprintf(file, "// (0: Left or Right Alt ; 1: Left Alt ; 2: Right Alt  \n");
      fprintf(file, "//  3: Left or Right Ctrl; 4: Left Ctrl; 5: Right Ctrl)\n");
      fprintf(file, "// Please do not enter the same value more than once.\n\n");
      fprintf(file, "CommandKey = %d\n", thePrefs.COMMAND);
      fprintf(file, "OptionKey = %d\n\n", thePrefs.OPTION);

      fprintf(file, "// How many frames should be displayed? vMac by default\n");
      fprintf(file, "// draws every frame (1) but on slower machines the\n");
      fprintf(file, "// emulation speed can be adjusted by entering a higher\n");
      fprintf(file, "// figure here. (Minimum value = 1, Maximum Value = 10).\n\n");
      fprintf(file, "FrameRate = %d\n\n", thePrefs.FrameRate);

      fprintf(file, "// Sound emulation (Experimental!)                       \n");  
      fprintf(file, "// (0 = Off, 1 = On)                                  \n\n");    
      fprintf(file, "Sound = %d\n\n", thePrefs.Sound);

      fprintf(file, "// Change this to adjust CPU/Hardware balance.  A higher  \n");
      fprintf(file, "// value means more CPU instructions per hardware update  \n");
      fprintf(file, "// event. The default value (44050) is for iP133 computers\n");
      fprintf(file, "// (tip: Use higher values for faster computers, lower for\n");
      fprintf(file, "//       slower computers (eg. 8150 for 33mHz)          \n\n");
      fprintf(file, "CPU = %ld\n\n", thePrefs.Instrucs);

      fprintf(file, "// How much RAM do you want the emulated Mac Plus to\n");
      fprintf(file, "// have? (1 = 1 Mb, 2 = 2Mb, 4 = 4Mb).\n\n");
      fprintf(file, "RAMSize = %d\n\n", thePrefs.RAMSize);

      fprintf(file, "// Which disks are in the emulated disk drives? Where\n");
      fprintf(file, "// are they located?\n\n");
      fprintf(file, "DrivePath1 = %s\n", thePrefs.DrivePath[1]);
      fprintf(file, "DrivePath2 = %s\n", thePrefs.DrivePath[2]);
      fprintf(file, "DrivePath3 = %s\n\n", thePrefs.DrivePath[3]);

      fprintf(file, "// And where is the vMac.ROM file? If you have more\n");
      fprintf(file, "// than one you can put in the path for them all and\n");
      fprintf(file, "// vMac will allow you to switch between them!\n\n");
      fprintf(file, "ROMPath1 = %s\n", thePrefs.ROMPath[1]);
      fprintf(file, "ROMPath2 = %s\n", thePrefs.ROMPath[2]);
      fprintf(file, "ROMPath3 = %s\n", thePrefs.ROMPath[3]);
      fprintf(file, "CurrentROMPath = %d\n\n", thePrefs.CurrentROMPath);

      fprintf(file, "\n");
      fprintf(file, "// End of File");
      fclose(file);
   }
}
